unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, OleServer, CmAdmCtl, ExtCtrls, ImgList;

type
  TfServidores = class(TForm)
    COMAdminCatalog1: TCOMAdminCatalog;
    Button1: TButton;
    TreeView1: TTreeView;
    ComboBox1: TComboBox;
    Button2: TButton;
    Button3: TButton;
    ImageList1: TImageList;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fServidores: TfServidores;

implementation

{$R *.dfm}

procedure TfServidores.Button1Click(Sender: TObject);
var
  Applications : TCOMAdminCatalogCollection;
  Components   : TCOMAdminCatalogCollection;
  AppObject    : TCOMAdminCatalogObject;
  COMObject    : TCOMAdminCatalogObject;
  Interf       : TCOMAdminCatalogCollection;
  IntObject    : TCOMAdminCatalogObject;
  Methods      : TCOMAdminCatalogCollection;
  MetObject    : TCOMAdminCatalogObject;
  A,C,I,M      : Integer;
  Node, Node2,
  Node3, Node4 : TTreeNode;
begin
  Applications := COMAdminCatalog1.GetCollection('Applications');
  Applications.Populate;
  for a := 0 to Applications.Count -1 do
  begin
    AppObject := Applications.Get_Item(a);
    Node := TreeView1.Items.Add(Node, AppObject.Name);
    ComboBox1.Items.Add(AppObject.Name);
    Components := Applications.GetCollection('Components', AppObject.Key);
    Components.Populate;
    for c := 0 to Components.Count -1 do
    begin
      COMObject := Components.Get_Item(c);
      Node2     := TreeView1.Items.AddChild(Node, COMObject.Name);
      Interf    := Components.GetCollection('InterfacesForComponent',COMObject.Key);
      Interf.Populate;
      for i := 0 to Interf.Count -1 do
      begin
        IntObject := Interf.Get_Item(i);
        Node3     := TreeView1.Items.AddChild(Node2, IntObject.Name);
        Methods   := Interf.GetCollection('MethodsForInterface', IntObject.Key);
        Methods.Populate;
        for m := 0 to Methods.Count -1 do
        begin
          MetObject := Methods.Get_Item(m);
          Node4     := TreeView1.Items.AddChild(Node3, MetObject.Name);
        end;
      end;
    end;
  end;
end;

procedure TfServidores.Button2Click(Sender: TObject);
begin
  COMAdminCatalog1.StartApplication(ComboBox1.Text);
end;

procedure TfServidores.Button3Click(Sender: TObject);
begin
  COMAdminCatalog1.ShutdownApplication(ComboBox1.Text);
end;

end.
