unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    RichEdit1: TRichEdit;
    ServerSocket1: TServerSocket;
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  cMsg, cHora : String;
begin
  cMsg := Socket.ReceiveText();
  if (UpperCase(cMsg) ='DATETIMENOW') then begin
    cHora := FormatDateTime('dd/mm/yyyy',NOW) +' - '+ FormatDateTime('hh:mm:ss',NOW);
    Socket.SendText(cHora);
  end else begin
    Socket.SendText('Comando Invlido!');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ServerSocket1.Active := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  cNoticia : String;
  i : Integer;
begin
  cNoticia := Trim(Edit1.Text);
  for i := 0 to ServerSocket1.Socket.ActiveConnections - 1 do begin
    ServerSocket1.Socket.Connections[i].SendText(cNoticia);
  end;
  RichEdit1.Lines.Add(cNoticia);
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Socket.SendText('Cliente Conectado!');
end;

end.
