unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, DbChart, DB,
  DBClient, StdCtrls, ComCtrls, Buttons, Menus,
  TeePrevi, TeeGally, TeExport, TeeAbout;

type
  TForm1 = class(TForm)
    btnPrimeiro: TBitBtn;
    btnAnterior: TBitBtn;
    btnProximo: TBitBtn;
    btnUltimo: TBitBtn;
    btnSobre: TBitBtn;
    btnExportar: TBitBtn;
    btnGaleria: TBitBtn;
    btnImprimir: TBitBtn;
    ClientDataSet1: TClientDataSet;
    DBChart1: TDBChart;
    Series1: TBarSeries;
    procedure btnImprimirClick(Sender: TObject);
    procedure btnSobreClick(Sender: TObject);
    procedure btnGaleriaClick(Sender: TObject);
    procedure btnExportarClick(Sender: TObject);
    procedure btnProximoClick(Sender: TObject);
    procedure btnPrimeiroClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.btnImprimirClick(Sender: TObject);
begin
  //includa unit TeePrevi

  {desabilita a definio automtica das margens}
  DBChart1.PrintProportional := False;
  {define as margens}
  DBChart1.PrintMargins := Rect(5,5,5,5);
  {abre a janela de visualizao}
  ChartPreview(Self, DBChart1);
end;

procedure TForm1.btnSobreClick(Sender: TObject);
begin
  //includa unit TeeAbout
  TeeShowAboutBox;
end;

procedure TForm1.btnGaleriaClick(Sender: TObject);
begin
  //includa unit TeeGally
  ChangeAllSeriesGallery(Self, DBChart1);
end;

procedure TForm1.btnExportarClick(Sender: TObject);
begin
  //includa unit TeExport
  with TTeeExportForm.Create(Self) do
  try
    ExportPanel:= DBChart1;
    ShowModal;
  finally
    Free;
  end;
end;

procedure TForm1.btnProximoClick(Sender: TObject);
begin
  if Sender = btnPrimeiro then
     DBChart1.Page := 1
  else if Sender = btnAnterior then
     DBChart1.PreviousPage
  else if Sender = btnProximo then
     DBChart1.NextPage
  else DBChart1.Page := DBChart1.NumPages;

  btnPrimeiro.Enabled := DBChart1.Page > 1;
  btnAnterior.Enabled := btnPrimeiro.Enabled;
  btnProximo.Enabled := DBChart1.Page < DBChart1.NumPages;
  btnUltimo.Enabled := btnProximo.Enabled;

  DBChart1.Foot.Text.Text := format(#13'Pgina %d de %d', [DBChart1.Page, DBChart1.NumPages]);
end;

procedure TForm1.btnPrimeiroClick(Sender: TObject);
begin
  if Sender = btnPrimeiro then
     DBChart1.Page := 1
  else if Sender = btnAnterior then
     DBChart1.PreviousPage
  else if Sender = btnProximo then
     DBChart1.NextPage
  else DBChart1.Page := DBChart1.NumPages;

  btnPrimeiro.Enabled := DBChart1.Page > 1;
  btnAnterior.Enabled := btnPrimeiro.Enabled;
  btnProximo.Enabled := DBChart1.Page < DBChart1.NumPages;
  btnUltimo.Enabled := btnProximo.Enabled;

  DBChart1.Foot.Text.Text := format('Pgina %d de %d', [DBChart1.Page, DBChart1.NumPages]);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    btnPrimeiro.Click;
end;

end.
