unit uexemploxmlbanco;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, ExtCtrls, DBXpress, DB, 
  xmldom, FMTBcd, Xmlxform, Provider, IBDatabase, IBCustomDataSet, IBQuery,
  DBClient, IBTable;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    btngravaxmlbanco: TButton;
    btnExtraiXMLBanco: TButton;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBTable1: TIBTable;
    DataSetProvider1: TDataSetProvider;
    XMLTransformClient1: TXMLTransformClient;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btngravaxmlbancoClick(Sender: TObject);
    procedure btnExtraiXMLBancoClick(Sender: TObject);
  private
    { Private declarations }
    FXml : TStringlist;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  IBDatabase1.Connected := True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IBDatabase1.Connected := False;
end;

procedure TForm1.btngravaxmlbancoClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    try
      FXml := TStringList.Create;
      FXml.Clear;
      FXml.LoadFromFile(OpenDialog1.FileName);
      try
        XMLTransformClient1.ApplyUpdates(FXml.Text,'',0);
        showmessage('Arquivo xml gravado com xito!');
      except
        showmessage('Erro ao gravar xml!');
      end;
    finally
      FXml.Free;
    end;
  end;
end;

procedure TForm1.btnExtraiXMLBancoClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    try
      FXml := TStringList.Create;
      FXml.Clear;
      FXml.Text := XMLTransformClient1.GetDataAsXml('');
      FXml.SaveToFile(SaveDialog1.FileName);
    finally
      FXml.Free;
    end;
  end;
end;

end.
